#line 1 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/TP_Test_driver.c"
#line 1 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/tp_test_objects.h"
typedef enum {_taLeft, _taCenter, _taRight} TTextAlign;

typedef struct Screen TScreen;

typedef struct {
 unsigned int X_Min;
 unsigned int X_Max;
 unsigned int Y_Min;
 unsigned int Y_Max;
 char Rotate;
} TTPConstants;

typedef struct Button {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Transparent;
 char *Caption;
 TTextAlign TextAlign;
 const char *FontName;
 unsigned int Font_Color;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 char PressColEnabled;
 unsigned int Press_Color;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TButton;

typedef struct Button_Round {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Transparent;
 char *Caption;
 TTextAlign TextAlign;
 const char *FontName;
 unsigned int Font_Color;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 char Corner_Radius;
 char PressColEnabled;
 unsigned int Press_Color;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TButton_Round;

typedef struct Label {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char *Caption;
 const char *FontName;
 unsigned int Font_Color;
 char Visible;
 char Active;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TLabel;

typedef struct CircleButton {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Radius;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Transparent;
 char *Caption;
 TTextAlign TextAlign;
 const char *FontName;
 unsigned int Font_Color;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 char PressColEnabled;
 unsigned int Press_Color;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TCircleButton;

typedef struct CheckBox {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Checked;
 char Transparent;
 char *Caption;
 TTextAlign TextAlign;
 const char *FontName;
 unsigned int Font_Color;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 char Rounded;
 char Corner_Radius;
 char PressColEnabled;
 unsigned int Press_Color;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TCheckBox;

struct Screen {
 unsigned int Color;
 unsigned int Width;
 unsigned int Height;
 unsigned int ObjectsCount;
 unsigned int ButtonsCount;
 TButton * const code *Buttons;
 unsigned int Buttons_RoundCount;
 TButton_Round * const code *Buttons_Round;
 unsigned int LabelsCount;
 TLabel * const code *Labels;
 unsigned int CircleButtonsCount;
 TCircleButton * const code *CircleButtons;
 unsigned int CheckBoxesCount;
 TCheckBox * const code *CheckBoxes;
};

extern TScreen Screen1;
extern TButton Button1;
extern TButton_Round ButtonRound1;
extern TCircleButton CircleButton1;
extern TLabel Label1;
extern TCheckBox CheckBox1;
extern TButton * const code Screen1_Buttons[1];
extern TButton_Round * const code Screen1_Buttons_Round[1];
extern TLabel * const code Screen1_Labels[1];
extern TCircleButton * const code Screen1_CircleButtons[1];
extern TCheckBox * const code Screen1_CheckBoxes[1];




void Button1OnPress();
void ButtonRound1OnPress();
void CheckBox1OnPress();
void CircleButton1OnPress();




extern char Button1_Caption[];
extern char ButtonRound1_Caption[];
extern char CircleButton1_Caption[];
extern char Label1_Caption[];
extern char CheckBox1_Caption[];


void DrawScreen(TScreen *aScreen);
void DrawButton(TButton *aButton);
void DrawRoundButton(TButton_Round *Around_button);
void DrawLabel(TLabel *ALabel);
void DrawCircleButton(TCircleButton *ACircle_button);
void DrawCheckBox(TCheckBox *ACheckBox);
void Check_TP();
void Start_TP();
void Process_TP_Press(unsigned int X, unsigned int Y);
void Process_TP_Up(unsigned int X, unsigned int Y);
void Process_TP_Down(unsigned int X, unsigned int Y);
#line 1 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/tp_test_resources.h"
const code char Tahoma16x19_Regular[];
const code char Tahoma26x33_Regular[];
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/built_in.h"
#line 7 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/TP_Test_driver.c"
unsigned int TFT_DataPort at GPIOE_ODR;
sbit TFT_RST at GPIOF_ODR.B14;
sbit TFT_RS at GPIOF_ODR.B15;
sbit TFT_CS at GPIOF_ODR.B13;
sbit TFT_RD at GPIOF_ODR.B12;
sbit TFT_WR at GPIOF_ODR.B11;
sbit TFT_BLED at GPIOF_ODR.B10;




unsigned int Xcoord, Ycoord;
char PenDown;
void *PressedObject;
int PressedObjectType;
unsigned int caption_length, caption_height;
unsigned int display_width, display_height;

int _object_count;
unsigned short object_pressed;
TButton *local_button;
TButton *exec_button;
int button_order;
TButton_Round *local_round_button;
TButton_Round *exec_round_button;
int round_button_order;
TLabel *local_label;
TLabel *exec_label;
int label_order;
TCircleButton *local_circle_button;
TCircleButton *exec_circle_button;
int circle_button_order;
TCheckBox *local_checkbox;
TCheckBox *exec_checkbox;
int checkbox_order;
extern char STMPE_State;

void Write_to_Data_Lines(unsigned char _hi, unsigned char _lo) {
 unsigned int temp;
 temp = GPIOE_ODR;
 temp &= 0x00FF;
 GPIOE_ODR = temp | (_hi << 8);
 temp = GPIOG_ODR;
 temp &= 0xFF00;
 GPIOG_ODR = temp | _lo;
}

void Set_Index(unsigned short index) {
 TFT_RS = 0;
 Write_to_Data_Lines(0, index);
 TFT_WR = 0;
 asm nop;
 TFT_WR = 1;
}

void Write_Command(unsigned short cmd) {
 TFT_RS = 1;
 Write_to_Data_Lines(0, cmd);
 TFT_WR = 0;
 asm nop;
 TFT_WR = 1;
}

void Write_Data(unsigned int _data) {
 TFT_RS = 1;
 Write_to_Data_Lines( ((char *)&_data)[1] ,  ((char *)&_data)[0] );
 TFT_WR = 0;
 asm nop;
 TFT_WR = 1;
}

static void InitializeTouchPanel() {
 TFT_Set_Active(Set_Index, Write_Command, Write_Data);
 TFT_Init_SSD1963(480, 272);

 TFT_Set_DBC_SSD1963(255);

 PenDown = 0;
 PressedObject = 0;
 PressedObjectType = -1;
}



 TScreen* CurrentScreen;

 TScreen Screen1;
 TButton Button1;
char Button1_Caption[7] = "Square";

 TButton_Round ButtonRound1;
char ButtonRound1_Caption[8] = "Rounded";

 TCircleButton CircleButton1;
char CircleButton1_Caption[6] = "Round";

 TLabel Label1;
char Label1_Caption[19] = "Touch Panel Tester";

 TCheckBox CheckBox1;
char CheckBox1_Caption[6] = "Check";

 TButton * const code Screen1_Buttons[1]=
 {
 &Button1
 };
 TButton_Round * const code Screen1_Buttons_Round[1]=
 {
 &ButtonRound1
 };
 TLabel * const code Screen1_Labels[1]=
 {
 &Label1
 };
 TCircleButton * const code Screen1_CircleButtons[1]=
 {
 &CircleButton1
 };
 TCheckBox * const code Screen1_CheckBoxes[1]=
 {
 &CheckBox1
 };



static void InitializeObjects() {
 Screen1.Color = 0xC618;
 Screen1.Width = 480;
 Screen1.Height = 272;
 Screen1.ButtonsCount = 1;
 Screen1.Buttons = Screen1_Buttons;
 Screen1.Buttons_RoundCount = 1;
 Screen1.Buttons_Round = Screen1_Buttons_Round;
 Screen1.LabelsCount = 1;
 Screen1.Labels = Screen1_Labels;
 Screen1.CircleButtonsCount = 1;
 Screen1.CircleButtons = Screen1_CircleButtons;
 Screen1.CheckBoxesCount = 1;
 Screen1.CheckBoxes = Screen1_CheckBoxes;
 Screen1.ObjectsCount = 5;


 Button1.OwnerScreen = &Screen1;
 Button1.Order = 0;
 Button1.Left = 44;
 Button1.Top = 76;
 Button1.Width = 80;
 Button1.Height = 80;
 Button1.Pen_Width = 1;
 Button1.Pen_Color = 0x0000;
 Button1.Visible = 1;
 Button1.Active = 1;
 Button1.Transparent = 1;
 Button1.Caption = Button1_Caption;
 Button1.TextAlign = _taCenter;
 Button1.FontName = Tahoma16x19_Regular;
 Button1.PressColEnabled = 1;
 Button1.Font_Color = 0xF81F;
 Button1.Gradient = 1;
 Button1.Gradient_Orientation = 0;
 Button1.Gradient_Start_Color = 0x001F;
 Button1.Gradient_End_Color = 0xC618;
 Button1.Color = 0xC618;
 Button1.Press_Color = 0xE71C;
 Button1.OnUpPtr = 0;
 Button1.OnDownPtr = 0;
 Button1.OnClickPtr = 0;
 Button1.OnPressPtr = Button1OnPress;

 ButtonRound1.OwnerScreen = &Screen1;
 ButtonRound1.Order = 1;
 ButtonRound1.Left = 182;
 ButtonRound1.Top = 76;
 ButtonRound1.Width = 80;
 ButtonRound1.Height = 80;
 ButtonRound1.Pen_Width = 1;
 ButtonRound1.Pen_Color = 0x0000;
 ButtonRound1.Visible = 1;
 ButtonRound1.Active = 1;
 ButtonRound1.Transparent = 1;
 ButtonRound1.Caption = ButtonRound1_Caption;
 ButtonRound1.TextAlign = _taCenter;
 ButtonRound1.FontName = Tahoma16x19_Regular;
 ButtonRound1.PressColEnabled = 1;
 ButtonRound1.Font_Color = 0x0014;
 ButtonRound1.Gradient = 1;
 ButtonRound1.Gradient_Orientation = 0;
 ButtonRound1.Gradient_Start_Color = 0xF81F;
 ButtonRound1.Gradient_End_Color = 0xC618;
 ButtonRound1.Color = 0xC618;
 ButtonRound1.Press_Color = 0xE71C;
 ButtonRound1.Corner_Radius = 3;
 ButtonRound1.OnUpPtr = 0;
 ButtonRound1.OnDownPtr = 0;
 ButtonRound1.OnClickPtr = 0;
 ButtonRound1.OnPressPtr = ButtonRound1OnPress;

 CircleButton1.OwnerScreen = &Screen1;
 CircleButton1.Order = 2;
 CircleButton1.Left = 326;
 CircleButton1.Top = 76;
 CircleButton1.Radius = 40;
 CircleButton1.Pen_Width = 1;
 CircleButton1.Pen_Color = 0x0000;
 CircleButton1.Visible = 1;
 CircleButton1.Active = 1;
 CircleButton1.Transparent = 1;
 CircleButton1.Caption = CircleButton1_Caption;
 CircleButton1.TextAlign = _taCenter;
 CircleButton1.FontName = Tahoma16x19_Regular;
 CircleButton1.PressColEnabled = 1;
 CircleButton1.Font_Color = 0xFC00;
 CircleButton1.Gradient = 1;
 CircleButton1.Gradient_Orientation = 0;
 CircleButton1.Gradient_Start_Color = 0x07E0;
 CircleButton1.Gradient_End_Color = 0xC618;
 CircleButton1.Color = 0xC618;
 CircleButton1.Press_Color = 0xE71C;
 CircleButton1.OnUpPtr = 0;
 CircleButton1.OnDownPtr = 0;
 CircleButton1.OnClickPtr = 0;
 CircleButton1.OnPressPtr = CircleButton1OnPress;

 Label1.OwnerScreen = &Screen1;
 Label1.Order = 3;
 Label1.Left = 46;
 Label1.Top = 196;
 Label1.Width = 236;
 Label1.Height = 36;
 Label1.Visible = 1;
 Label1.Active = 1;
 Label1.Caption = Label1_Caption;
 Label1.FontName = Tahoma26x33_Regular;
 Label1.Font_Color = 0xF800;
 Label1.OnUpPtr = 0;
 Label1.OnDownPtr = 0;
 Label1.OnClickPtr = 0;
 Label1.OnPressPtr = 0;

 CheckBox1.OwnerScreen = &Screen1;
 CheckBox1.Order = 4;
 CheckBox1.Left = 334;
 CheckBox1.Top = 193;
 CheckBox1.Width = 84;
 CheckBox1.Height = 36;
 CheckBox1.Pen_Width = 1;
 CheckBox1.Pen_Color = 0x0000;
 CheckBox1.Visible = 1;
 CheckBox1.Active = 1;
 CheckBox1.Checked = 1;
 CheckBox1.Transparent = 1;
 CheckBox1.Caption = CheckBox1_Caption;
 CheckBox1.TextAlign = _taLeft;
 CheckBox1.FontName = Tahoma16x19_Regular;
 CheckBox1.PressColEnabled = 1;
 CheckBox1.Font_Color = 0x0000;
 CheckBox1.Gradient = 1;
 CheckBox1.Gradient_Orientation = 0;
 CheckBox1.Gradient_Start_Color = 0xFFFF;
 CheckBox1.Gradient_End_Color = 0xC618;
 CheckBox1.Color = 0xC618;
 CheckBox1.Press_Color = 0xE71C;
 CheckBox1.Rounded = 1;
 CheckBox1.Corner_Radius = 3;
 CheckBox1.OnUpPtr = 0;
 CheckBox1.OnDownPtr = 0;
 CheckBox1.OnClickPtr = 0;
 CheckBox1.OnPressPtr = CheckBox1OnPress;
}

static char IsInsideObject (unsigned int X, unsigned int Y, unsigned int Left, unsigned int Top, unsigned int Width, unsigned int Height) {
 if ( (Left<= X) && (Left+ Width - 1 >= X) &&
 (Top <= Y) && (Top + Height - 1 >= Y) )
 return 1;
 else
 return 0;
}









void DrawButton(TButton *Abutton) {
 if (Abutton->Visible == 1) {
 if (object_pressed == 1) {
 object_pressed = 0;
 TFT_Set_Brush(Abutton->Transparent, Abutton->Press_Color, Abutton->Gradient, Abutton->Gradient_Orientation, Abutton->Gradient_End_Color, Abutton->Gradient_Start_Color);
 }
 else {
 TFT_Set_Brush(Abutton->Transparent, Abutton->Color, Abutton->Gradient, Abutton->Gradient_Orientation, Abutton->Gradient_Start_Color, Abutton->Gradient_End_Color);
 }
 TFT_Set_Pen(Abutton->Pen_Color, Abutton->Pen_Width);
 TFT_Rectangle(Abutton->Left, Abutton->Top, Abutton->Left + Abutton->Width - 1, Abutton->Top + Abutton->Height - 1);
 TFT_Set_Font(Abutton->FontName, Abutton->Font_Color, FO_HORIZONTAL);
 TFT_Write_Text_Return_Pos(Abutton->Caption, Abutton->Left, Abutton->Top);
 if (Abutton->TextAlign == _taLeft)
 TFT_Write_Text(Abutton->Caption, Abutton->Left + 4, (Abutton->Top + ((Abutton->Height - caption_height) / 2)));
 else if (Abutton->TextAlign == _taCenter)
 TFT_Write_Text(Abutton->Caption, (Abutton->Left + (Abutton->Width - caption_length) / 2), (Abutton->Top + ((Abutton->Height - caption_height) / 2)));
 else if (Abutton->TextAlign == _taRight)
 TFT_Write_Text(Abutton->Caption, Abutton->Left + (Abutton->Width - caption_length - 4), (Abutton->Top + (Abutton->Height - caption_height) / 2));
 }
}

void DrawRoundButton(TButton_Round *Around_button) {
 if (Around_button->Visible == 1) {
 if (object_pressed == 1) {
 object_pressed = 0;
 TFT_Set_Brush(Around_button->Transparent, Around_button->Press_Color, Around_button->Gradient, Around_button->Gradient_Orientation,
 Around_button->Gradient_End_Color, Around_button->Gradient_Start_Color);
 }
 else {
 TFT_Set_Brush(Around_button->Transparent, Around_button->Color, Around_button->Gradient, Around_button->Gradient_Orientation,
 Around_button->Gradient_Start_Color, Around_button->Gradient_End_Color);
 }
 TFT_Set_Pen(Around_button->Pen_Color, Around_button->Pen_Width);
 TFT_Rectangle_Round_Edges(Around_button->Left + 1, Around_button->Top + 1,
 Around_button->Left + Around_button->Width - 2,
 Around_button->Top + Around_button->Height - 2, Around_button->Corner_Radius);
 TFT_Set_Font(Around_button->FontName, Around_button->Font_Color, FO_HORIZONTAL);
 TFT_Write_Text_Return_Pos(Around_button->Caption, Around_button->Left, Around_button->Top);
 if (Around_button->TextAlign == _taLeft)
 TFT_Write_Text(Around_button->Caption, Around_button->Left + 4, (Around_button->Top + ((Around_button->Height - caption_height) / 2)));
 else if (Around_button->TextAlign == _taCenter)
 TFT_Write_Text(Around_button->Caption, (Around_button->Left + (Around_button->Width - caption_length) / 2), (Around_button->Top + ((Around_button->Height - caption_height) / 2)));
 else if (Around_button->TextAlign == _taRight)
 TFT_Write_Text(Around_button->Caption, Around_button->Left + (Around_button->Width - caption_length - 4), (Around_button->Top + (Around_button->Height - caption_height) / 2));
 }
}

void DrawLabel(TLabel *ALabel) {
 if (ALabel->Visible == 1) {
 TFT_Set_Font(ALabel->FontName, ALabel->Font_Color, FO_HORIZONTAL);
 TFT_Write_Text(ALabel->Caption, ALabel->Left, ALabel->Top);
 }
}

void DrawCircleButton(TCircleButton *ACircle_button) {
 if (ACircle_button->Visible == 1) {
 if (object_pressed == 1) {
 object_pressed = 0;
 TFT_Set_Brush(ACircle_button->Transparent, ACircle_button->Press_Color, ACircle_button->Gradient, ACircle_button->Gradient_Orientation,
 ACircle_button->Gradient_End_Color, ACircle_button->Gradient_Start_Color);
 }
 else {
 TFT_Set_Brush(ACircle_button->Transparent, ACircle_button->Color, ACircle_button->Gradient, ACircle_button->Gradient_Orientation,
 ACircle_button->Gradient_Start_Color, ACircle_button->Gradient_End_Color);
 }
 TFT_Set_Pen(ACircle_button->Pen_Color, ACircle_button->Pen_Width);
 TFT_Circle(ACircle_button->Left + ACircle_button->Radius,
 ACircle_button->Top + ACircle_button->Radius,
 ACircle_button->Radius);
 TFT_Set_Font(ACircle_button->FontName, ACircle_button->Font_Color, FO_HORIZONTAL);
 TFT_Write_Text_Return_Pos(ACircle_button->Caption, ACircle_button->Left, ACircle_button->Top);
 if (ACircle_button->TextAlign == _taLeft)
 TFT_Write_Text(ACircle_button->Caption, ACircle_button->Left + 4, (ACircle_button->Top + ACircle_button->Radius - caption_height / 2));
 else if (ACircle_button->TextAlign == _taCenter)
 TFT_Write_Text(ACircle_button->Caption, (ACircle_button->Left + (ACircle_button->Radius*2 - caption_length) / 2), (ACircle_button->Top + ACircle_button->Radius - caption_height / 2));
 else if (ACircle_button->TextAlign == _taRight)
 TFT_Write_Text(ACircle_button->Caption, ACircle_button->Left + (ACircle_button->Radius*2 - caption_length - 4), (ACircle_button->Top + ACircle_button->Radius - caption_height / 2));
 }
}

void DrawCheckBox(TCheckBox *ACheckBox) {
 if (ACheckBox->Visible == 1) {
 if (object_pressed == 1) {
 object_pressed = 0;
 TFT_Set_Brush(ACheckBox->Transparent, ACheckBox->Press_Color, ACheckBox->Gradient, ACheckBox->Gradient_Orientation, ACheckBox->Gradient_End_Color, ACheckBox->Gradient_Start_Color);
 }
 else {
 TFT_Set_Brush(ACheckBox->Transparent, ACheckBox->Color, ACheckBox->Gradient, ACheckBox->Gradient_Orientation, ACheckBox->Gradient_Start_Color, ACheckBox->Gradient_End_Color);
 }
 TFT_Set_Pen(ACheckBox->Pen_Color, ACheckBox->Pen_Width);
 TFT_Set_Font(ACheckBox->FontName, ACheckBox->Font_Color, FO_HORIZONTAL);
 if (ACheckBox->TextAlign == _taLeft) {
 if (ACheckBox->Rounded == 1)
 TFT_Rectangle_Round_Edges(ACheckBox->Left, ACheckBox->Top, ACheckBox->Left + ACheckBox->Height, ACheckBox->Top + ACheckBox->Height - 1, ACheckBox->Corner_Radius);
 else
 TFT_Rectangle(ACheckBox->Left, ACheckBox->Top, ACheckBox->Left + ACheckBox->Height, ACheckBox->Top + ACheckBox->Height - 1);
 if (ACheckBox->Checked == 1) {
 TFT_Set_Pen(ACheckBox->Pen_Color, ACheckBox->Height / 8);
 TFT_Line(ACheckBox->Left + ACheckBox->Height / 5 + 1,
 ACheckBox->Top + ACheckBox->Height / 2 + 1,
 ACheckBox->Left + ACheckBox->Height / 2 - 1,
 ACheckBox->Top + ACheckBox->Height - ACheckBox->Height / 5 - 1);
 TFT_Line(ACheckBox->Left + ACheckBox->Height / 2 - ACheckBox->Pen_Width + 1,
 ACheckBox->Top + ACheckBox->Height - ACheckBox->Height / 5 - 1,
 ACheckBox->Left + ACheckBox->Height - ACheckBox->Height / 5 - 1,
 ACheckBox->Top + ACheckBox->Height / 5 + 1);
 }
 TFT_Write_Text_Return_Pos(ACheckBox->Caption, ACheckBox->Left + ACheckBox->Width / 4 + 3, ACheckBox->Top);
 TFT_Write_Text(ACheckBox->Caption, ACheckBox->Left + ACheckBox->Height + 3, (ACheckBox->Top + ((ACheckBox->Height - caption_height) / 2)));
 }
 else if (ACheckBox->TextAlign == _taRight) {
 if (ACheckBox->Rounded == 1)
 TFT_Rectangle_Round_Edges(ACheckBox->Left + ACheckBox->Width - ACheckBox->Height , ACheckBox->Top, ACheckBox->Left + ACheckBox->Width, ACheckBox->Top + ACheckBox->Height - 1, ACheckBox->Corner_Radius);
 else
 TFT_Rectangle(ACheckBox->Left + ACheckBox->Width - ACheckBox->Height , ACheckBox->Top, ACheckBox->Left + ACheckBox->Width, ACheckBox->Top + ACheckBox->Height - 1);
 if (ACheckBox->Checked == 1) {
 TFT_Set_Pen(ACheckBox->Pen_Color, ACheckBox->Height / 8);
 TFT_Line(ACheckBox->Left + ACheckBox->Width - ACheckBox->Height + ACheckBox->Height / 5 + 1,
 ACheckBox->Top + ACheckBox->Height / 2 + 1,
 ACheckBox->Left + ACheckBox->Width - ACheckBox->Height /2 - 1,
 ACheckBox->Top + ACheckBox->Height - ACheckBox->Height / 5 - 1);
 TFT_Line(ACheckBox->Left + ACheckBox->Width - ACheckBox->Height /2 + 1,
 ACheckBox->Top + ACheckBox->Height - ACheckBox->Height / 5 - 1,
 ACheckBox->Left + ACheckBox->Width - ACheckBox->Height / 5 - 1,
 ACheckBox->Top + ACheckBox->Height / 5 + 1);
 }
 TFT_Write_Text_Return_Pos(ACheckBox->Caption, ACheckBox->Left + 3, ACheckBox->Top);
 TFT_Write_Text(ACheckBox->Caption, ACheckBox->Left + 3, ACheckBox->Top + (ACheckBox->Height - caption_height) / 2);
 }
 }
}

void DrawScreen(TScreen *aScreen) {
 unsigned int order;
 unsigned short button_idx;
 TButton *local_button;
 unsigned short round_button_idx;
 TButton_Round *local_round_button;
 unsigned short label_idx;
 TLabel *local_label;
 unsigned short circle_button_idx;
 TCircleButton *local_circle_button;
 unsigned short checkbox_idx;
 TCheckBox *local_checkbox;
 char save_bled, save_bled_direction;

 object_pressed = 0;
 order = 0;
 button_idx = 0;
 round_button_idx = 0;
 label_idx = 0;
 circle_button_idx = 0;
 checkbox_idx = 0;
 CurrentScreen = aScreen;

 if ((display_width != CurrentScreen->Width) || (display_height != CurrentScreen->Height)) {
 save_bled = TFT_BLED;
 TFT_BLED = 0;
 TFT_Set_Active(Set_Index, Write_Command, Write_Data);
 TFT_Init_SSD1963(CurrentScreen->Width, CurrentScreen->Height);

 TFT_Fill_Screen(CurrentScreen->Color);
 TFT_Set_DBC_SSD1963(255);
 display_width = CurrentScreen->Width;
 display_height = CurrentScreen->Height;
 TFT_BLED = save_bled;
 }
 else
 TFT_Fill_Screen(CurrentScreen->Color);


 while (order < CurrentScreen->ObjectsCount) {
 if (button_idx < CurrentScreen->ButtonsCount) {
 local_button =  CurrentScreen->Buttons[button_idx] ;
 if (order == local_button->Order) {
 button_idx++;
 order++;
 DrawButton(local_button);
 }
 }

 if (round_button_idx < CurrentScreen->Buttons_RoundCount) {
 local_round_button =  CurrentScreen->Buttons_Round[round_button_idx] ;
 if (order == local_round_button->Order) {
 round_button_idx++;
 order++;
 DrawRoundButton(local_round_button);
 }
 }

 if (label_idx < CurrentScreen->LabelsCount) {
 local_label =  CurrentScreen->Labels[label_idx] ;
 if (order == local_label->Order) {
 label_idx++;
 order++;
 DrawLabel(local_label);
 }
 }

 if (circle_button_idx < CurrentScreen->CircleButtonsCount) {
 local_circle_button =  CurrentScreen->CircleButtons[circle_button_idx] ;
 if (order == local_circle_button->Order) {
 circle_button_idx++;
 order++;
 DrawCircleButton(local_circle_button);
 }
 }

 if (checkbox_idx < CurrentScreen->CheckBoxesCount) {
 local_checkbox =  CurrentScreen->CheckBoxes[checkbox_idx] ;
 if (order == local_checkbox->Order) {
 checkbox_idx++;
 order++;
 DrawCheckBox(local_checkbox);
 }
 }

 }
}

void Get_Object(unsigned int X, unsigned int Y) {
 button_order = -1;
 round_button_order = -1;
 label_order = -1;
 circle_button_order = -1;
 checkbox_order = -1;

 for ( _object_count = 0 ; _object_count < CurrentScreen->ButtonsCount ; _object_count++ ) {
 local_button =  CurrentScreen->Buttons[_object_count] ;
 if (local_button->Active == 1) {
 if (IsInsideObject(X, Y, local_button->Left, local_button->Top,
 local_button->Width, local_button->Height) == 1) {
 button_order = local_button->Order;
 exec_button = local_button;
 }
 }
 }


 for ( _object_count = 0 ; _object_count < CurrentScreen->Buttons_RoundCount ; _object_count++ ) {
 local_round_button =  CurrentScreen->Buttons_Round[_object_count] ;
 if (local_round_button->Active == 1) {
 if (IsInsideObject(X, Y, local_round_button->Left, local_round_button->Top,
 local_round_button->Width, local_round_button->Height) == 1) {
 round_button_order = local_round_button->Order;
 exec_round_button = local_round_button;
 }
 }
 }


 for ( _object_count = 0 ; _object_count < CurrentScreen->LabelsCount ; _object_count++ ) {
 local_label =  CurrentScreen->Labels[_object_count] ;
 if (local_label->Active == 1) {
 if (IsInsideObject(X, Y, local_label->Left, local_label->Top,
 local_label->Width, local_label->Height) == 1) {
 label_order = local_label->Order;
 exec_label = local_label;
 }
 }
 }


 for ( _object_count = 0 ; _object_count < CurrentScreen->CircleButtonsCount ; _object_count++ ) {
 local_circle_button =  CurrentScreen->CircleButtons[_object_count] ;
 if (local_circle_button->Active == 1) {
 if (IsInsideObject(X, Y, local_circle_button->Left, local_circle_button->Top,
 (local_circle_button->Radius * 2), (local_circle_button->Radius * 2)) == 1) {
 circle_button_order = local_circle_button->Order;
 exec_circle_button = local_circle_button;
 }
 }
 }


 for ( _object_count = 0 ; _object_count < CurrentScreen->CheckBoxesCount ; _object_count++ ) {
 local_checkbox =  CurrentScreen->CheckBoxes[_object_count] ;
 if (local_checkbox->Active == 1) {
 if (IsInsideObject(X, Y, local_checkbox->Left, local_checkbox->Top,
 local_checkbox->Width, local_checkbox->Height) == 1) {
 checkbox_order = local_checkbox->Order;
 exec_checkbox = local_checkbox;
 }
 }
 }

 _object_count = -1;
 if (button_order > _object_count )
 _object_count = button_order;
 if (round_button_order > _object_count )
 _object_count = round_button_order;
 if (label_order > _object_count )
 _object_count = label_order;
 if (circle_button_order > _object_count )
 _object_count = circle_button_order;
 if (checkbox_order > _object_count )
 _object_count = checkbox_order;
}


void Process_TP_Press(unsigned int X, unsigned int Y) {
 exec_button = 0;
 exec_round_button = 0;
 exec_label = 0;
 exec_circle_button = 0;
 exec_checkbox = 0;

 Get_Object(X, Y);

 if (_object_count != -1) {
 if (_object_count == button_order) {
 if (exec_button->Active == 1) {
 if (exec_button->OnPressPtr != 0) {
 exec_button->OnPressPtr();
 return;
 }
 }
 }

 if (_object_count == round_button_order) {
 if (exec_round_button->Active == 1) {
 if (exec_round_button->OnPressPtr != 0) {
 exec_round_button->OnPressPtr();
 return;
 }
 }
 }

 if (_object_count == label_order) {
 if (exec_label->Active == 1) {
 if (exec_label->OnPressPtr != 0) {
 exec_label->OnPressPtr();
 return;
 }
 }
 }

 if (_object_count == circle_button_order) {
 if (exec_circle_button->Active == 1) {
 if (exec_circle_button->OnPressPtr != 0) {
 exec_circle_button->OnPressPtr();
 return;
 }
 }
 }

 if (_object_count == checkbox_order) {
 if (exec_checkbox->Active == 1) {
 if (exec_checkbox->OnPressPtr != 0) {
 exec_checkbox->OnPressPtr();
 return;
 }
 }
 }

 }
}

void Process_TP_Up(unsigned int X, unsigned int Y) {

 switch (PressedObjectType) {

 case 0: {
 if (PressedObject != 0) {
 exec_button = (TButton*)PressedObject;
 if ((exec_button->PressColEnabled == 1) && (exec_button->OwnerScreen == CurrentScreen)) {
 DrawButton(exec_button);
 }
 break;
 }
 break;
 }

 case 1: {
 if (PressedObject != 0) {
 exec_round_button = (TButton_Round*)PressedObject;
 if ((exec_round_button->PressColEnabled == 1) && (exec_round_button->OwnerScreen == CurrentScreen)) {
 DrawRoundButton(exec_round_button);
 }
 break;
 }
 break;
 }

 case 5: {
 if (PressedObject != 0) {
 exec_circle_button = (TCircleButton*)PressedObject;
 if ((exec_circle_button->PressColEnabled == 1) && (exec_circle_button->OwnerScreen == CurrentScreen)) {
 DrawCircleButton(exec_circle_button);
 }
 break;
 }
 break;
 }

 case 16: {
 if (PressedObject != 0) {
 exec_checkbox = (TCheckBox*)PressedObject;
 break;
 }
 break;
 }
 }

 exec_label = 0;

 Get_Object(X, Y);


 if (_object_count != -1) {

 if (_object_count == button_order) {
 if (exec_button->Active == 1) {
 if (exec_button->OnUpPtr != 0)
 exec_button->OnUpPtr();
 if (PressedObject == (void *)exec_button)
 if (exec_button->OnClickPtr != 0)
 exec_button->OnClickPtr();
 PressedObject = 0;
 PressedObjectType = -1;
 return;
 }
 }


 if (_object_count == round_button_order) {
 if (exec_round_button->Active == 1) {
 if (exec_round_button->OnUpPtr != 0)
 exec_round_button->OnUpPtr();
 if (PressedObject == (void *)exec_round_button)
 if (exec_round_button->OnClickPtr != 0)
 exec_round_button->OnClickPtr();
 PressedObject = 0;
 PressedObjectType = -1;
 return;
 }
 }


 if (_object_count == label_order) {
 if (exec_label->Active == 1) {
 if (exec_label->OnUpPtr != 0)
 exec_label->OnUpPtr();
 if (PressedObject == (void *)exec_label)
 if (exec_label->OnClickPtr != 0)
 exec_label->OnClickPtr();
 PressedObject = 0;
 PressedObjectType = -1;
 return;
 }
 }


 if (_object_count == circle_button_order) {
 if (exec_circle_button->Active == 1) {
 if (exec_circle_button->OnUpPtr != 0)
 exec_circle_button->OnUpPtr();
 if (PressedObject == (void *)exec_circle_button)
 if (exec_circle_button->OnClickPtr != 0)
 exec_circle_button->OnClickPtr();
 PressedObject = 0;
 PressedObjectType = -1;
 return;
 }
 }


 if (_object_count == checkbox_order) {
 if (exec_checkbox->Active == 1) {
 if (exec_checkbox->OnUpPtr != 0)
 exec_checkbox->OnUpPtr();
 if (PressedObject == (void *)exec_checkbox) {
 if (exec_checkbox->Checked == 1)
 exec_checkbox->Checked = 0;
 else
 exec_checkbox->Checked = 1;
 DrawCheckBox(exec_checkbox);
 if (exec_checkbox->OnClickPtr != 0)
 exec_checkbox->OnClickPtr();
 }
 PressedObject = 0;
 PressedObjectType = -1;
 return;
 }
 }

 }
 PressedObject = 0;
 PressedObjectType = -1;
}

void Process_TP_Down(unsigned int X, unsigned int Y) {

 object_pressed = 0;
 exec_button = 0;
 exec_round_button = 0;
 exec_label = 0;
 exec_circle_button = 0;
 exec_checkbox = 0;

 Get_Object(X, Y);

 if (_object_count != -1) {
 if (_object_count == button_order) {
 if (exec_button->Active == 1) {
 if (exec_button->PressColEnabled == 1) {
 object_pressed = 1;
 DrawButton(exec_button);
 }
 PressedObject = (void *)exec_button;
 PressedObjectType = 0;
 if (exec_button->OnDownPtr != 0) {
 exec_button->OnDownPtr();
 return;
 }
 }
 }

 if (_object_count == round_button_order) {
 if (exec_round_button->Active == 1) {
 if (exec_round_button->PressColEnabled == 1) {
 object_pressed = 1;
 DrawRoundButton(exec_round_button);
 }
 PressedObject = (void *)exec_round_button;
 PressedObjectType = 1;
 if (exec_round_button->OnDownPtr != 0) {
 exec_round_button->OnDownPtr();
 return;
 }
 }
 }

 if (_object_count == label_order) {
 if (exec_label->Active == 1) {
 PressedObject = (void *)exec_label;
 PressedObjectType = 2;
 if (exec_label->OnDownPtr != 0) {
 exec_label->OnDownPtr();
 return;
 }
 }
 }

 if (_object_count == circle_button_order) {
 if (exec_circle_button->Active == 1) {
 if (exec_circle_button->PressColEnabled == 1) {
 object_pressed = 1;
 DrawCircleButton(exec_circle_button);
 }
 PressedObject = (void *)exec_circle_button;
 PressedObjectType = 5;
 if (exec_circle_button->OnDownPtr != 0) {
 exec_circle_button->OnDownPtr();
 return;
 }
 }
 }

 if (_object_count == checkbox_order) {
 if (exec_checkbox->Active == 1) {
 if (exec_checkbox->PressColEnabled == 1) {
 object_pressed = 1;
 DrawCheckBox(exec_checkbox);
 }
 PressedObject = (void *)exec_checkbox;
 PressedObjectType = 16;
 if (exec_checkbox->OnDownPtr != 0) {
 exec_checkbox->OnDownPtr();
 return;
 }
 }
 }

 }
}

void Check_TP() {
 if (STMPE610_PressDetect()) {
 if (STMPE610_GetLastCoordinates(&Xcoord, &Ycoord) == 0) {

 Process_TP_Press(Xcoord, Ycoord);
 if (PenDown == 0) {
 PenDown = 1;
 Process_TP_Down(Xcoord, Ycoord);
 }
 }
 }
 else if (PenDown == 1) {
 PenDown = 0;
 Process_TP_Up(Xcoord, Ycoord);
 }
}

void Init_MCU() {
#line 903 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/TP_Test_driver.c"
 TFT_Set_Default_Mode();
 GPIO_Digital_Output(&GPIOG_BASE, 0x00FF);
 GPIO_Digital_Output(&GPIOE_BASE, 0xFF00);
 GPIO_Digital_Output(&GPIOB_BASE, _GPIO_PINMASK_4);
 GPIOB_ODR.B4 = 0;
 TFT_Set_Default_Mode();
 TFT_Set_MM_Plus();

}

char STMPE610_Config() {
 STMPE610_SetI2CAddress(STMPE610_I2C_ADDR1);
 if (STMPE610_IsOperational() != 0){
 return STMPE610_IO_NOT_OPERATIONAL;
 }

 STMPE610_Reset();
 STMPE610_Module(STMPE610_MODULE_TS | STMPE610_MODULE_ADC, STMPE610_ENABLE);
 STMPE610_AlternateFunction(STMPE610_GPIO_PIN1, STMPE610_ENABLE);
 STMPE610_SetGPIOPin(STMPE610_GPIO_PIN1, 0);
 STMPE610_SetSize(480,272);
 STMPE610_Module(STMPE610_MODULE_TS | STMPE610_MODULE_ADC, STMPE610_ENABLE);
 STMPE610_EnableInterrupt(STMPE610_IE_TOUCH_DET | STMPE610_IE_FIFO_TH, STMPE610_ENABLE);
 STMPE610_ConfigureInterrupt(STMPE610_INT_POLARITY_ACTIVE_LOW | STMPE610_INT_TYPE_EDGE | STMPE610_INT_ENABLE_ALL);
 STMPE610_SetADC(STMPE610_ADC_CTRL1_SAMPLETIME_44 | STMPE610_ADC_CTRL1_ADC_12BIT | STMPE610_ADC_CTRL1_INT_REFERENCE);
 Delay_10ms(); Delay_10ms();
 STMPE610_SetADCClock(STMPE610_ADC_CTRL2_3250_kHZ);
 STMPE610_AlternateFunction(STMPE610_GPIO_PIN4 | STMPE610_GPIO_PIN5 | STMPE610_GPIO_PIN6 | STMPE610_GPIO_PIN7, STMPE610_DISABLE);
 STMPE610_ConfigureTSC(STMPE610_TSC_CFG_AVE_CTRL_8S, STMPE610_TSC_CFG_TOUCH_DET_DELAY_50mS, STMPE610_TSC_CFG_TOUCH_SETTLING_100mS);
 STMPE610_SetFIFOThreshold(1);
 STMPE610_ResetFIFO();
 STMPE610_TSIDrive(STMPE610_TSC_I_DRIVE_20mA);
 STMPE610_TSControl(STMPE610_TSC_CTRL_TRACK0 | STMPE610_TSC_CTRL_ACQU_XYZ | STMPE610_TSC_CTRL_ENABLE);
 STMPE610_ZDataFraction(STMPE610_FRACP4_WHOLP4);
 STMPE610_SetTouchPressureThreshold(70);
 STMPE610_ClearInterrupts();
 STMPE610_WriteReg(STMPE610_INT_CTRL_REG, 0x01);
 return STMPE610_OK;
}


void Start_TP() {
TTPConstants TPConstsStruct;
 Init_MCU();

 InitializeTouchPanel();
#line 964 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/TP_Test_driver.c"
 InitializeObjects();
 display_width = Screen1.Width;
 display_height = Screen1.Height;
 DrawScreen(&Screen1);
 STMPE_State = 1;
}
