/*
 * Project name:
     TP_Test.vtft
 * Generated by:
     Visual TFT
 * Date of creation
     24/05/2015
 * Time of creation
     2:26:33 PM
 * Test configuration:
     MCU:             STM32F407ZG
     Dev.Board:       Vals_Mikromedia_Plus_for_STM32_ARM
     Oscillator:      25 MHz
     PLL:             120 MHz
     SW:              mikroC PRO for ARM

  * NOTES:
      1. Replaced mikroE I2C1 and STMPE610 drivers.




*/

#include "TP_Test_objects.h"
#include "UART6.h"
#include "USB_Driver.h"
#include "RGB.h"
#include "Timers.h"
#include "I2C.h"
#include "STMPE610.h"



void main() {

     UART6_Initialize();
     UART6_PutQueue("Started\r\n");

     USB_Init();                       // Initialize USB
     RGB_Init();                       // Initialize RGB LEDs
     Timer_Init();                     // Initialize timer
     ExtIntEnable();                   // Enable external interrupt from STMPE610
     I2C1_Initialize();                // Initialize I2C1

     Start_TP();
     
     EnableInterrupts();               // Enable interrupts
     
     
     
     
     
     
     while (1) {

     
          USB_CheckIn();               // Check for incoming USB messages
          USB_CheckOut();              // Check for outgoing USB messages

          UART6_Rx();                  // Check for incoming UART6 messages
          UART6_CheckQueue();          // Check for outgoing UART6 messages

          I2C1_SM();                   // Run the I2C1 state machine
          STMPE_SM();                  // Run the STMPE610 state machine

          TimerCheck();                // Check timer pool
          GetFifo();                   // Check for STMPE610 command in fifo
     }
}
