#line 1 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/TP_Test_main.c"
#line 1 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/tp_test_objects.h"
typedef enum {_taLeft, _taCenter, _taRight} TTextAlign;

typedef struct Screen TScreen;

typedef struct {
 unsigned int X_Min;
 unsigned int X_Max;
 unsigned int Y_Min;
 unsigned int Y_Max;
 char Rotate;
} TTPConstants;

typedef struct Button {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Transparent;
 char *Caption;
 TTextAlign TextAlign;
 const char *FontName;
 unsigned int Font_Color;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 char PressColEnabled;
 unsigned int Press_Color;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TButton;

typedef struct Button_Round {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Transparent;
 char *Caption;
 TTextAlign TextAlign;
 const char *FontName;
 unsigned int Font_Color;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 char Corner_Radius;
 char PressColEnabled;
 unsigned int Press_Color;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TButton_Round;

typedef struct Label {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char *Caption;
 const char *FontName;
 unsigned int Font_Color;
 char Visible;
 char Active;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TLabel;

typedef struct CircleButton {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Radius;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Transparent;
 char *Caption;
 TTextAlign TextAlign;
 const char *FontName;
 unsigned int Font_Color;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 char PressColEnabled;
 unsigned int Press_Color;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TCircleButton;

typedef struct CheckBox {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Checked;
 char Transparent;
 char *Caption;
 TTextAlign TextAlign;
 const char *FontName;
 unsigned int Font_Color;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 char Rounded;
 char Corner_Radius;
 char PressColEnabled;
 unsigned int Press_Color;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TCheckBox;

struct Screen {
 unsigned int Color;
 unsigned int Width;
 unsigned int Height;
 unsigned int ObjectsCount;
 unsigned int ButtonsCount;
 TButton * const code *Buttons;
 unsigned int Buttons_RoundCount;
 TButton_Round * const code *Buttons_Round;
 unsigned int LabelsCount;
 TLabel * const code *Labels;
 unsigned int CircleButtonsCount;
 TCircleButton * const code *CircleButtons;
 unsigned int CheckBoxesCount;
 TCheckBox * const code *CheckBoxes;
};

extern TScreen Screen1;
extern TButton Button1;
extern TButton_Round ButtonRound1;
extern TCircleButton CircleButton1;
extern TLabel Label1;
extern TCheckBox CheckBox1;
extern TButton * const code Screen1_Buttons[1];
extern TButton_Round * const code Screen1_Buttons_Round[1];
extern TLabel * const code Screen1_Labels[1];
extern TCircleButton * const code Screen1_CircleButtons[1];
extern TCheckBox * const code Screen1_CheckBoxes[1];




void Button1OnPress();
void ButtonRound1OnPress();
void CheckBox1OnPress();
void CircleButton1OnPress();




extern char Button1_Caption[];
extern char ButtonRound1_Caption[];
extern char CircleButton1_Caption[];
extern char Label1_Caption[];
extern char CheckBox1_Caption[];


void DrawScreen(TScreen *aScreen);
void DrawButton(TButton *aButton);
void DrawRoundButton(TButton_Round *Around_button);
void DrawLabel(TLabel *ALabel);
void DrawCircleButton(TCircleButton *ACircle_button);
void DrawCheckBox(TCheckBox *ACheckBox);
void Check_TP();
void Start_TP();
void Process_TP_Press(unsigned int X, unsigned int Y);
void Process_TP_Up(unsigned int X, unsigned int Y);
void Process_TP_Down(unsigned int X, unsigned int Y);
#line 1 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/uart6.h"
#line 19 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/uart6.h"
typedef void (*tPointerFcn)(void);





void UART6_SetBaud(void);
void UART6_StartRx(void);
void UART6_StartTx(void);

void UART6_Initialize(void);

void UART6_RxQueueInit(void);
char UART6_GetChar(char *rxbyte);

void UART6_Rx(void);
void UART6_Rx1(void);
void UART6_Rx2(void);


void UART6_TxQueueInit(void);
void UART6_PutQueue(char *msg);

void UART6_SendMsg(char *s);
void UART6_CheckQueue(void);
#line 1 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/usb_driver.h"
#line 11 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/usb_driver.h"
typedef char *pnt;


typedef struct USB_TxStruct {
 unsigned int in;
 unsigned int out;
 pnt q[ 32 ];
}USB_TxStruct;



void USB_Init(void);
void USB_TxQueueInit(void);
void USB_PutQueue(char *msg);
void USB_CheckOut(void);
void USB_CheckIn(void);
#line 1 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/rgb.h"
#line 13 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/rgb.h"
void RGB_Init(void);
void RGB_Set_Red(void);
void RGB_Clr_Red(void);
void RGB_Set_Green(void);
void RGB_Clr_Green(void);
void RGB_Set_Blue(void);
void RGB_Clr_Blue(void);
#line 1 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/timers.h"
#line 9 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/timers.h"
void Timer_Init();
void TimerCheck();
#line 31 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/timers.h"
struct timers {
 unsigned long int TimerField;
 unsigned short int Free;
};
#line 43 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/timers.h"
void init_timerpool(void);
#line 52 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/timers.h"
unsigned short int get_timer(void);
#line 61 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/timers.h"
void free_timer(unsigned short int nbr);
#line 71 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/timers.h"
void set_timer(unsigned short int nbr, unsigned long int tout);
#line 80 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/timers.h"
unsigned long int check_timer(unsigned short int nbr);
#line 89 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/timers.h"
void irqhandler_timer(void);
#line 1 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/i2c.h"
#line 15 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/i2c.h"
void I2C1_Initialize(void);
void ReadRegs(char Addr, char Cnt, char *Bfr);
void WriteRegs(char Addr, char Cnt, char *Bfr);
void DisplayData(char *Bfr, char Cnt);
void TimeoutCheck(unsigned TimeoutState);

void I2C1_SM(void);
#line 1 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/stmpe610.h"
#line 66 "c:/arm projects/mikromedia+ for stm32 arm/tp_test/tp_test_code/mikroc pro for arm/stmpe610.h"
typedef struct {
 char *Buff;
 char CmdCode;
 char RegAd;
 char Count;
} TCommand;



void ExtIntEnable(void);
void ExtIntEnable(void);

void PutFifo(char *Bfr, char Cmd, char Addr, char Cnt);
char GetFifo(void);
void STMPE_TimeoutCheck(unsigned TimeoutState);
void STMPE_SM(void);


void Set_Index(unsigned short index);
void Write_Command(unsigned short cmd);
void Write_Data(unsigned int _data);
#line 35 "C:/ARM Projects/Mikromedia+ for STM32 ARM/TP_Test/TP_Test_Code/mikroC PRO for ARM/TP_Test_main.c"
void main() {

 UART6_Initialize();
 UART6_PutQueue("Started\r\n");

 USB_Init();
 RGB_Init();
 Timer_Init();
 ExtIntEnable();
 I2C1_Initialize();

 Start_TP();

 EnableInterrupts();






 while (1) {


 USB_CheckIn();
 USB_CheckOut();

 UART6_Rx();
 UART6_CheckQueue();

 I2C1_SM();
 STMPE_SM();

 TimerCheck();
 GetFifo();
 }
}
