_UART6_Interrupt:
;UART6.c,40 :: 		void UART6_Interrupt() iv IVT_INT_USART6 ics ICS_AUTO {
;UART6.c,45 :: 		if ((RXNE_USART6_SR_bit) /* || (ORE_bit) */ ) {
MOVW	R1, #lo_addr(RXNE_USART6_SR_bit+0)
MOVT	R1, #hi_addr(RXNE_USART6_SR_bit+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	EQ
BEQ	L_UART6_Interrupt0
;UART6.c,46 :: 		R_data = USART6_DR;           // Fetch a byte from receive register
MOVW	R0, #lo_addr(USART6_DR+0)
MOVT	R0, #hi_addr(USART6_DR+0)
; R_data start address is: 12 (R3)
LDR	R3, [R0, #0]
;UART6.c,47 :: 		RxQueue[RxIn++] = R_data;     // Put data byte in re-circulating buffer, increment pointer
MOVW	R2, #lo_addr(_RxIn+0)
MOVT	R2, #hi_addr(_RxIn+0)
LDRB	R1, [R2, #0]
MOVW	R0, #lo_addr(_RxQueue+0)
MOVT	R0, #hi_addr(_RxQueue+0)
ADDS	R0, R0, R1
STRB	R3, [R0, #0]
; R_data end address is: 12 (R3)
MOV	R0, R2
LDRB	R0, [R0, #0]
ADDS	R0, R0, #1
UXTB	R0, R0
STRB	R0, [R2, #0]
;UART6.c,48 :: 		if (RxIn > (rxqsize-1))       // Adjust pointer if necessary
CMP	R0, #255
IT	LS
BLS	L_UART6_Interrupt1
;UART6.c,49 :: 		RxIn = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_RxIn+0)
MOVT	R0, #hi_addr(_RxIn+0)
STRB	R1, [R0, #0]
L_UART6_Interrupt1:
;UART6.c,50 :: 		}
L_UART6_Interrupt0:
;UART6.c,52 :: 		if ((TXE_USART6_SR_bit)&&(TXEIE_USART6_CR1_bit)) {
MOVW	R1, #lo_addr(TXE_USART6_SR_bit+0)
MOVT	R1, #hi_addr(TXE_USART6_SR_bit+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	EQ
BEQ	L__UART6_Interrupt29
MOVW	R1, #lo_addr(TXEIE_USART6_CR1_bit+0)
MOVT	R1, #hi_addr(TXEIE_USART6_CR1_bit+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	EQ
BEQ	L__UART6_Interrupt28
L__UART6_Interrupt27:
;UART6.c,53 :: 		T_data = XmtBuf[XmtBufPtr++]; // Get a byte from the transmit buffer
MOVW	R2, #lo_addr(_XmtBufPtr+0)
MOVT	R2, #hi_addr(_XmtBufPtr+0)
LDRB	R1, [R2, #0]
MOVW	R0, #lo_addr(_XmtBuf+0)
MOVT	R0, #hi_addr(_XmtBuf+0)
LDR	R0, [R0, #0]
ADDS	R0, R0, R1
LDRB	R1, [R0, #0]
; T_data start address is: 12 (R3)
UXTB	R3, R1
MOV	R0, R2
LDRB	R0, [R0, #0]
ADDS	R0, R0, #1
STRB	R0, [R2, #0]
;UART6.c,54 :: 		if (T_data == NUL) {          // If it is the end of message marker
CMP	R1, #0
IT	NE
BNE	L_UART6_Interrupt5
; T_data end address is: 12 (R3)
;UART6.c,55 :: 		TXEIE_USART6_CR1_bit = 0; // Disable transmitter interrupts
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(TXEIE_USART6_CR1_bit+0)
MOVT	R0, #hi_addr(TXEIE_USART6_CR1_bit+0)
STR	R1, [R0, #0]
;UART6.c,56 :: 		} else {
IT	AL
BAL	L_UART6_Interrupt6
L_UART6_Interrupt5:
;UART6.c,57 :: 		USART6_DR = T_data;       // Transfer data byte to transmit register
; T_data start address is: 12 (R3)
MOVW	R0, #lo_addr(USART6_DR+0)
MOVT	R0, #hi_addr(USART6_DR+0)
STR	R3, [R0, #0]
; T_data end address is: 12 (R3)
;UART6.c,58 :: 		}
L_UART6_Interrupt6:
;UART6.c,52 :: 		if ((TXE_USART6_SR_bit)&&(TXEIE_USART6_CR1_bit)) {
L__UART6_Interrupt29:
L__UART6_Interrupt28:
;UART6.c,60 :: 		}
L_end_UART6_Interrupt:
BX	LR
; end of _UART6_Interrupt
_UART6_SetBaud:
;UART6.c,64 :: 		void UART6_SetBaud(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;UART6.c,65 :: 		UART6_Init_Advanced(9600,_UART_8_BIT_DATA,_UART_NOPARITY,_UART_ONE_STOPBIT,&_GPIO_MODULE_USART6_PC67);
MOVW	R0, #lo_addr(__GPIO_MODULE_USART6_PC67+0)
MOVT	R0, #hi_addr(__GPIO_MODULE_USART6_PC67+0)
PUSH	(R0)
MOVW	R3, #0
MOVW	R2, #0
MOVW	R1, #0
MOVW	R0, #9600
BL	_UART6_Init_Advanced+0
ADD	SP, SP, #4
;UART6.c,66 :: 		NVIC_IntEnable(IVT_INT_USART6);   // Enable interrupt vector
MOVW	R0, #87
BL	_NVIC_IntEnable+0
;UART6.c,67 :: 		}
L_end_UART6_SetBaud:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _UART6_SetBaud
_UART6_StartRx:
;UART6.c,71 :: 		void UART6_StartRx(void) {
;UART6.c,72 :: 		RXNEIE_USART6_CR1_bit = 1;        // Interrupt when receive buffer is full (RXNE=1)
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(RXNEIE_USART6_CR1_bit+0)
MOVT	R0, #hi_addr(RXNEIE_USART6_CR1_bit+0)
STR	R1, [R0, #0]
;UART6.c,73 :: 		}
L_end_UART6_StartRx:
BX	LR
; end of _UART6_StartRx
_UART6_StartTx:
;UART6.c,77 :: 		void UART6_StartTx(void) {
;UART6.c,78 :: 		TXEIE_USART6_CR1_bit = 1;         // Interrupt when transmit buffer is empty (TXE=1)
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(TXEIE_USART6_CR1_bit+0)
MOVT	R0, #hi_addr(TXEIE_USART6_CR1_bit+0)
STR	R1, [R0, #0]
;UART6.c,79 :: 		}
L_end_UART6_StartTx:
BX	LR
; end of _UART6_StartTx
_UART6_Initialize:
;UART6.c,88 :: 		void UART6_Initialize(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;UART6.c,89 :: 		UART6_RxQueueInit();
BL	_UART6_RxQueueInit+0
;UART6.c,90 :: 		UART6_TxQueueInit();
BL	_UART6_TxQueueInit+0
;UART6.c,92 :: 		UART6_SetBaud();
BL	_UART6_SetBaud+0
;UART6.c,93 :: 		UART6_StartRx();
BL	_UART6_StartRx+0
;UART6.c,94 :: 		}
L_end_UART6_Initialize:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _UART6_Initialize
_UART6_RxQueueInit:
;UART6.c,99 :: 		void UART6_RxQueueInit(void) {
;UART6.c,100 :: 		RxIn = RxOut = 0;                 // Set pointers to 0
MOVS	R1, #0
MOVW	R0, #lo_addr(_RxOut+0)
MOVT	R0, #hi_addr(_RxOut+0)
STRB	R1, [R0, #0]
MOVS	R1, #0
MOVW	R0, #lo_addr(_RxIn+0)
MOVT	R0, #hi_addr(_RxIn+0)
STRB	R1, [R0, #0]
;UART6.c,101 :: 		RcvBufPtr = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_RcvBufPtr+0)
MOVT	R0, #hi_addr(_RcvBufPtr+0)
STRB	R1, [R0, #0]
;UART6.c,102 :: 		}
L_end_UART6_RxQueueInit:
BX	LR
; end of _UART6_RxQueueInit
_UART6_GetChar:
;UART6.c,108 :: 		char UART6_GetChar(char *rxbyte) {
; rxbyte start address is: 0 (R0)
; rxbyte end address is: 0 (R0)
; rxbyte start address is: 0 (R0)
;UART6.c,109 :: 		if (RxIn != RxOut) {              // If there is a character in the buffer
MOVW	R1, #lo_addr(_RxOut+0)
MOVT	R1, #hi_addr(_RxOut+0)
LDRB	R2, [R1, #0]
MOVW	R1, #lo_addr(_RxIn+0)
MOVT	R1, #hi_addr(_RxIn+0)
LDRB	R1, [R1, #0]
CMP	R1, R2
IT	EQ
BEQ	L_UART6_GetChar7
;UART6.c,110 :: 		*rxbyte = RxQueue[RxOut++];    // Extract the character and update the pointer
MOVW	R3, #lo_addr(_RxOut+0)
MOVT	R3, #hi_addr(_RxOut+0)
LDRB	R2, [R3, #0]
MOVW	R1, #lo_addr(_RxQueue+0)
MOVT	R1, #hi_addr(_RxQueue+0)
ADDS	R1, R1, R2
LDRB	R1, [R1, #0]
STRB	R1, [R0, #0]
; rxbyte end address is: 0 (R0)
MOV	R1, R3
LDRB	R1, [R1, #0]
ADDS	R1, R1, #1
UXTB	R1, R1
STRB	R1, [R3, #0]
;UART6.c,111 :: 		if (RxOut > (rxqsize-1))       // Check for wrap
CMP	R1, #255
IT	LS
BLS	L_UART6_GetChar8
;UART6.c,112 :: 		RxOut = 0;
MOVS	R2, #0
MOVW	R1, #lo_addr(_RxOut+0)
MOVT	R1, #hi_addr(_RxOut+0)
STRB	R2, [R1, #0]
L_UART6_GetChar8:
;UART6.c,113 :: 		return 1;
MOVS	R0, #1
IT	AL
BAL	L_end_UART6_GetChar
;UART6.c,114 :: 		}else{
L_UART6_GetChar7:
;UART6.c,115 :: 		return 0;                      // No data available
MOVS	R0, #0
;UART6.c,117 :: 		}
L_end_UART6_GetChar:
BX	LR
; end of _UART6_GetChar
_UART6_Rx:
;UART6.c,121 :: 		void UART6_Rx(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;UART6.c,122 :: 		UART6_RxFuncPtr();    // Use the function pointer to go to a state
MOVW	R4, #lo_addr(_UART6_RxFuncPtr+0)
MOVT	R4, #hi_addr(_UART6_RxFuncPtr+0)
LDR	R4, [R4, #0]
BLX	R4
;UART6.c,123 :: 		}
L_end_UART6_Rx:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _UART6_Rx
_UART6_Rx1:
;UART6.c,128 :: 		void UART6_Rx1(void){
SUB	SP, SP, #8
STR	LR, [SP, #0]
;UART6.c,131 :: 		if (UART6_GetChar(&rxchar)) {
ADD	R0, SP, #4
BL	_UART6_GetChar+0
CMP	R0, #0
IT	EQ
BEQ	L_UART6_Rx110
;UART6.c,132 :: 		switch (rxchar) {
IT	AL
BAL	L_UART6_Rx111
;UART6.c,133 :: 		case NUL:         // Discard NUL character
L_UART6_Rx113:
;UART6.c,134 :: 		break;
IT	AL
BAL	L_UART6_Rx112
;UART6.c,136 :: 		case '\r':        // Discard return character
L_UART6_Rx114:
;UART6.c,137 :: 		break;
IT	AL
BAL	L_UART6_Rx112
;UART6.c,139 :: 		case '\n':
L_UART6_Rx115:
;UART6.c,140 :: 		RcvBuf[RcvBufPtr++] = rxchar;       // Put received character into buffer
MOVW	R2, #lo_addr(_RcvBufPtr+0)
MOVT	R2, #hi_addr(_RcvBufPtr+0)
LDRB	R1, [R2, #0]
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
ADDS	R1, R0, R1
LDRB	R0, [SP, #4]
STRB	R0, [R1, #0]
MOV	R0, R2
LDRB	R0, [R0, #0]
ADDS	R1, R0, #1
UXTB	R1, R1
STRB	R1, [R2, #0]
;UART6.c,141 :: 		RcvBuf[RcvBufPtr] = 0;              // End marker
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
ADDS	R1, R0, R1
MOVS	R0, #0
STRB	R0, [R1, #0]
;UART6.c,142 :: 		RcvBufPtr = 0;                      // Point to start of buffer
MOVS	R0, #0
STRB	R0, [R2, #0]
;UART6.c,143 :: 		UART6_RxFuncPtr = UART6_Rx2;        // Go to state 2
MOVW	R1, #lo_addr(_UART6_Rx2+0)
MOVT	R1, #hi_addr(_UART6_Rx2+0)
MOVW	R0, #lo_addr(_UART6_RxFuncPtr+0)
MOVT	R0, #hi_addr(_UART6_RxFuncPtr+0)
STR	R1, [R0, #0]
;UART6.c,144 :: 		break;
IT	AL
BAL	L_UART6_Rx112
;UART6.c,146 :: 		default:
L_UART6_Rx116:
;UART6.c,147 :: 		if (RcvBufPtr < (RcvBufSize-2))     // Prevents buffer overrun
MOVW	R0, #lo_addr(_RcvBufPtr+0)
MOVT	R0, #hi_addr(_RcvBufPtr+0)
LDRB	R0, [R0, #0]
CMP	R0, #254
IT	CS
BCS	L_UART6_Rx117
;UART6.c,148 :: 		RcvBuf[RcvBufPtr++] = rxchar;   // Put character in buffer
MOVW	R2, #lo_addr(_RcvBufPtr+0)
MOVT	R2, #hi_addr(_RcvBufPtr+0)
LDRB	R1, [R2, #0]
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
ADDS	R1, R0, R1
LDRB	R0, [SP, #4]
STRB	R0, [R1, #0]
MOV	R0, R2
LDRB	R0, [R0, #0]
ADDS	R0, R0, #1
STRB	R0, [R2, #0]
L_UART6_Rx117:
;UART6.c,149 :: 		break;
IT	AL
BAL	L_UART6_Rx112
;UART6.c,150 :: 		}
L_UART6_Rx111:
LDRB	R0, [SP, #4]
CMP	R0, #0
IT	EQ
BEQ	L_UART6_Rx113
LDRB	R0, [SP, #4]
CMP	R0, #13
IT	EQ
BEQ	L_UART6_Rx114
LDRB	R0, [SP, #4]
CMP	R0, #10
IT	EQ
BEQ	L_UART6_Rx115
IT	AL
BAL	L_UART6_Rx116
L_UART6_Rx112:
;UART6.c,151 :: 		}
L_UART6_Rx110:
;UART6.c,152 :: 		}
L_end_UART6_Rx1:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _UART6_Rx1
_UART6_Rx2:
;UART6.c,157 :: 		void UART6_Rx2(void) {
SUB	SP, SP, #8
STR	LR, [SP, #0]
;UART6.c,160 :: 		switch (RcvBuf[0]) {
IT	AL
BAL	L_UART6_Rx218
;UART6.c,162 :: 		case 'a': // Diagnostic command to see if serial communications is working OK
L_UART6_Rx220:
;UART6.c,163 :: 		UART6_PutQueue("Command a received\r\n");
MOVW	R0, #lo_addr(?lstr1_UART6+0)
MOVT	R0, #hi_addr(?lstr1_UART6+0)
BL	_UART6_PutQueue+0
;UART6.c,164 :: 		break;
IT	AL
BAL	L_UART6_Rx219
;UART6.c,170 :: 		case 'z': // Do a software reset
L_UART6_Rx221:
;UART6.c,171 :: 		SystemReset();
BL	_SystemReset+0
;UART6.c,172 :: 		break;
IT	AL
BAL	L_UART6_Rx219
;UART6.c,175 :: 		default:  // Catch any unimplemented commands
L_UART6_Rx222:
;UART6.c,176 :: 		UART6_PutQueue("Unknown command: ");
MOVW	R0, #lo_addr(?lstr2_UART6+0)
MOVT	R0, #hi_addr(?lstr2_UART6+0)
BL	_UART6_PutQueue+0
;UART6.c,178 :: 		BufNum = GetBuffer();               // Get a free buffer
BL	_GetBuffer+0
; BufNum start address is: 12 (R3)
MOV	R3, R0
;UART6.c,179 :: 		(void)sprintf(BufNum,"%c\r\n",RcvBuf[0]);
MOVW	R1, #lo_addr(_RcvBuf+0)
MOVT	R1, #hi_addr(_RcvBuf+0)
LDRB	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_3_UART6+0)
MOVT	R1, #hi_addr(?lstr_3_UART6+0)
STR	R3, [SP, #4]
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
LDR	R3, [SP, #4]
;UART6.c,180 :: 		UART6_PutQueue(BufNum);             // Send the message
MOV	R0, R3
; BufNum end address is: 12 (R3)
BL	_UART6_PutQueue+0
;UART6.c,181 :: 		break;
IT	AL
BAL	L_UART6_Rx219
;UART6.c,182 :: 		}
L_UART6_Rx218:
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #97
IT	EQ
BEQ	L_UART6_Rx220
MOVW	R0, #lo_addr(_RcvBuf+0)
MOVT	R0, #hi_addr(_RcvBuf+0)
LDRB	R0, [R0, #0]
CMP	R0, #122
IT	EQ
BEQ	L_UART6_Rx221
IT	AL
BAL	L_UART6_Rx222
L_UART6_Rx219:
;UART6.c,183 :: 		UART6_RxFuncPtr = UART6_Rx1;                // Go back to state 1
MOVW	R1, #lo_addr(_UART6_Rx1+0)
MOVT	R1, #hi_addr(_UART6_Rx1+0)
MOVW	R0, #lo_addr(_UART6_RxFuncPtr+0)
MOVT	R0, #hi_addr(_UART6_RxFuncPtr+0)
STR	R1, [R0, #0]
;UART6.c,184 :: 		}
L_end_UART6_Rx2:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _UART6_Rx2
_UART6_TxQueueInit:
;UART6.c,191 :: 		void UART6_TxQueueInit(void) {
;UART6.c,192 :: 		TxIn = TxOut = 0;         // Set pointers to 0
MOVS	R1, #0
MOVW	R0, #lo_addr(_TxOut+0)
MOVT	R0, #hi_addr(_TxOut+0)
STRB	R1, [R0, #0]
MOVS	R1, #0
MOVW	R0, #lo_addr(_TxIn+0)
MOVT	R0, #hi_addr(_TxIn+0)
STRB	R1, [R0, #0]
;UART6.c,193 :: 		XmtBufPtr = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_XmtBufPtr+0)
MOVT	R0, #hi_addr(_XmtBufPtr+0)
STRB	R1, [R0, #0]
;UART6.c,194 :: 		}
L_end_UART6_TxQueueInit:
BX	LR
; end of _UART6_TxQueueInit
_UART6_PutQueue:
;UART6.c,199 :: 		void UART6_PutQueue(char *msg) {
; msg start address is: 0 (R0)
; msg end address is: 0 (R0)
; msg start address is: 0 (R0)
;UART6.c,200 :: 		TxQueue[TxIn++] = msg;    // Put the message pointer into FIFO
MOVW	R3, #lo_addr(_TxIn+0)
MOVT	R3, #hi_addr(_TxIn+0)
LDRB	R1, [R3, #0]
LSLS	R2, R1, #2
MOVW	R1, #lo_addr(_TxQueue+0)
MOVT	R1, #hi_addr(_TxQueue+0)
ADDS	R1, R1, R2
STR	R0, [R1, #0]
; msg end address is: 0 (R0)
MOV	R1, R3
LDRB	R1, [R1, #0]
ADDS	R2, R1, #1
UXTB	R2, R2
STRB	R2, [R3, #0]
;UART6.c,201 :: 		if (TxIn > (txqsize-1))   // Adjust FIFO in pointer
MOVW	R1, #511
CMP	R2, R1
IT	LE
BLE	L_UART6_PutQueue23
;UART6.c,202 :: 		TxIn = 0;
MOVS	R2, #0
MOVW	R1, #lo_addr(_TxIn+0)
MOVT	R1, #hi_addr(_TxIn+0)
STRB	R2, [R1, #0]
L_UART6_PutQueue23:
;UART6.c,203 :: 		}
L_end_UART6_PutQueue:
BX	LR
; end of _UART6_PutQueue
_UART6_SendMsg:
;UART6.c,207 :: 		void UART6_SendMsg(char *s) {
; s start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; s end address is: 0 (R0)
; s start address is: 0 (R0)
;UART6.c,208 :: 		XmtBuf = s;               // Pointer to the message for the interrupt handler
MOVW	R1, #lo_addr(_XmtBuf+0)
MOVT	R1, #hi_addr(_XmtBuf+0)
STR	R0, [R1, #0]
; s end address is: 0 (R0)
;UART6.c,209 :: 		XmtBufPtr = 0;            // Set character counter to start of text message
MOVS	R2, #0
MOVW	R1, #lo_addr(_XmtBufPtr+0)
MOVT	R1, #hi_addr(_XmtBufPtr+0)
STRB	R2, [R1, #0]
;UART6.c,210 :: 		UART6_StartTx();          // Turn on the transmitter
BL	_UART6_StartTx+0
;UART6.c,211 :: 		}
L_end_UART6_SendMsg:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _UART6_SendMsg
_UART6_CheckQueue:
;UART6.c,216 :: 		void UART6_CheckQueue(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;UART6.c,217 :: 		if (TXEIE_USART6_CR1_bit == 0) {   // Don't try to start transmitter if already transmitting
MOVW	R1, #lo_addr(TXEIE_USART6_CR1_bit+0)
MOVT	R1, #hi_addr(TXEIE_USART6_CR1_bit+0)
LDR	R0, [R1, #0]
CMP	R0, #0
IT	NE
BNE	L_UART6_CheckQueue24
;UART6.c,218 :: 		if (TxIn != TxOut) {                 // If pointers are not the same
MOVW	R0, #lo_addr(_TxOut+0)
MOVT	R0, #hi_addr(_TxOut+0)
LDRB	R1, [R0, #0]
MOVW	R0, #lo_addr(_TxIn+0)
MOVT	R0, #hi_addr(_TxIn+0)
LDRB	R0, [R0, #0]
CMP	R0, R1
IT	EQ
BEQ	L_UART6_CheckQueue25
;UART6.c,219 :: 		UART6_SendMsg(TxQueue[TxOut++]); // Hand off the message pointer and increment counter
MOVW	R0, #lo_addr(_TxOut+0)
MOVT	R0, #hi_addr(_TxOut+0)
LDRB	R0, [R0, #0]
LSLS	R1, R0, #2
MOVW	R0, #lo_addr(_TxQueue+0)
MOVT	R0, #hi_addr(_TxQueue+0)
ADDS	R0, R0, R1
LDR	R0, [R0, #0]
BL	_UART6_SendMsg+0
MOVW	R2, #lo_addr(_TxOut+0)
MOVT	R2, #hi_addr(_TxOut+0)
LDRB	R0, [R2, #0]
ADDS	R1, R0, #1
UXTB	R1, R1
STRB	R1, [R2, #0]
;UART6.c,220 :: 		if (TxOut > (txqsize-1))         // Check for wrap
MOVW	R0, #511
CMP	R1, R0
IT	LE
BLE	L_UART6_CheckQueue26
;UART6.c,221 :: 		TxOut = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_TxOut+0)
MOVT	R0, #hi_addr(_TxOut+0)
STRB	R1, [R0, #0]
L_UART6_CheckQueue26:
;UART6.c,222 :: 		}
L_UART6_CheckQueue25:
;UART6.c,223 :: 		}
L_UART6_CheckQueue24:
;UART6.c,224 :: 		}
L_end_UART6_CheckQueue:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _UART6_CheckQueue
